import datetime

import pandas as pd

df = pd.read_csv("D:\data\白玉山后评估数据资料\十分钟.csv", encoding='utf8')

df['时间'] = pd.to_datetime(df['时间'])
df['plus_10min'] = df['时间'] + pd.Timedelta(minutes=10)

names = set(df['设备名称'])


def get_time_space_count(start_time: datetime.datetime, end_time: datetime.datetime, time_space=1):
    """
    获取俩个时间之间的个数
    :return: 查询时间间隔
    """
    delta = end_time - start_time
    total_seconds = delta.days * 24 * 60 * 60 + delta.seconds

    return abs(int(total_seconds / time_space))


result_dict = dict()
for name in names:
    q_df = df[df['设备名称'] == name]
    q_df['unshift'] = q_df['时间'].shift(-1)
    q_df.fillna('2024-09-01 00:00:00', inplace=True)
    result_df = q_df[~(q_df['plus_10min'] == q_df['unshift'])]
    result_df.reset_index(inplace=True)
    q_list = list()
    count = 0
    result_df.to_csv('test.csv', encoding='utf8')
    for i in range(result_df.shape[0]):
        data = result_df.iloc[i]
        begin = data['时间']
        end = data['unshift']
        count = count + get_time_space_count(begin, end, 600) - 1
        # if end is not None and end != np.nan:
        #     q_list.append(f"{begin} ~ {end}")

    result_dict[name] = count

with open("缺失_数量.csv", 'w', encoding='utf8') as f:
    for k, v in result_dict.items():
        # v.insert(0, k)
        # f.write(",".join(v) + "\n")
        f.write(f"{k},{v}\n")
